﻿# -*- coding: utf-8 -*-

from struct import *

# http://bb.osmocom.org/trac/attachment/wiki/GSMTAP/gsmtap.h

class GSMTAP:
	def __init__(self, gsmtap):
		self.gsmtap = gsmtap

		setattr(self, "version", ord(gsmtap[0]))
		setattr(self, "hdr_len", ord(gsmtap[1]) << 2)
		setattr(self, "payload_type", ord(gsmtap[2]))

		setattr(self, "time_slot", ord(gsmtap[3]))
		ARFCN = (ord(gsmtap[4])&0x3F)*0x100 + ord(gsmtap[5])
		UPLINK = ord(gsmtap[4]) >> 6
		setattr(self, "arfcn", ARFCN)
		setattr(self, "link", UPLINK)

		setattr(self, "signal_noise", ord(gsmtap[6]))
		setattr(self, "signal_level", ord(gsmtap[7]))
		# GSM Frame Number
		setattr(self, "channel_type", ord(gsmtap[12]))
		setattr(self, "antenna_number", ord(gsmtap[13]))
		setattr(self, "sub_slot", ord(gsmtap[14]))

	def get_payload(self):
		return self.gsmtap[self.hdr_len:]

class LAPDm:
	def __init__(self, lapdm):
		setattr(self, "lapdm", lapdm)

		setattr(self, "addr_field", ord(lapdm[0]))
		setattr(self, "lpd", (ord(lapdm[0])>>5)&0x3)
		setattr(self, "sapi", (ord(lapdm[0])>>2)&0x7)

		setattr(self, "ctrl_field", ord(lapdm[1]))
		setattr(self, "n_r", ord(lapdm[1])>>5)
		setattr(self, "n_s", (ord(lapdm[1])>>1)&0x7)

		setattr(self, "len_field", ord(lapdm[2]))
		setattr(self, "has_more", (ord(lapdm[2])>>1)&0x1)
		setattr(self, "length", ord(lapdm[2])>>2)

	def get_data(self):
		return self.lapdm[3:]
