﻿# -*- coding: utf-8 -*-

import os
import sys
import re
import binascii
from struct import pack, unpack

class UDP:
	def _nint(self, buf, off, len):
		if (len == 1):
			return unpack('!B', buf[off])[0]
		elif (len == 2):
			return unpack('!H', buf[off:off+2])[0]
		elif (len == 4):
			return unpack('!L', buf[off:off+4])[0]
		elif (len == 8):
			return unpack('!Q', buf[off:off+8])[0]
		else:
			return None

	def __init__(self, packet):
		setattr(self, "packet", packet)

		iOff = 0
		ip_hdr_len_b = self._nint(packet, iOff, 1); iOff += 1
		setattr(self, "ip_hdr_len", (ip_hdr_len_b & 0x0F) * 4)
		
		# check protocol - UDP 17
		iOff += 8
		setattr(self, "ip_protocol", self._nint(packet, iOff, 1)); iOff += 1
		if (self.ip_protocol != 17):
			raise Exception("unknow ip protocol %d" % self.ip_protocol)

		setattr(self, "udp_hdr_off", self.ip_hdr_len)

		# udp header
		iOff = self.udp_hdr_off
		iOff += 4
		setattr(self, "payload_len", self._nint(packet, iOff, 2) - 8); iOff += 2
		setattr(self, "payload_off", self.udp_hdr_off+8)


	def get_payload(self):
		return self.packet[self.payload_off:self.payload_off+self.payload_len]